
# Copyright (C) 2006 David Brodsky
#
# This library is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation and appearing in the file LICENSE.LGPL included in the
# packaging of this file.
#
# This library is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.

# This script generates header file for signals implemented in C++. If a
# parameter on the command line is given, then output is written to it;
# otherwise it is written to stdout.

import sys

# Number of signal types to generate. Total number of signalCount - 1
# parameters can be passed to the signal, the first parameter specifies return
# type
signalCount = 4

# Important variables and substitutions:
# header, footer - Header, footer of the output
# template - Template for one type. Substitutions are made in it.
# #args#   - arguments that can be passed to a function: arg1, arg2 ...
# #aagrs#  - types of arguments: TArg1, TArg2 ...
# #cargs#  - argumets that can be passed to a function, prepended with a comma:
#            , arg1, arg2 ...
# #dargs#  - definitions of parameters used in a class definition:
#            \n\t\tTArg1;\n\t\tTarg2; ...
# #iargs#  - initializations of arguments: , arg1(a1), arg2(a2) ...
# #margs#  - method arguments: TArg1 arg1, TArg2 arg2 ...
# #targs#  - template arguments: , TArg1, TArg2 ...
# #cdargs# - compact method arguments, prepended with a comma:
#            , TArg1 a1, TArg2 a2 ...
# #tdargs# - template parameters: , class TArg1, class TArg2 ...
# #tvargs# - template parameters: class TArg1, class TArg2 ...

header = """// This file is generated by signals.py script. Any changes made to this file
// may be lost. See signals.py for copyright informations.

#ifndef _tairon_core_signals_h
#define _tairon_core_signals_h

#include <list>

#include "mutex.h"
#include "thread.h"

namespace Tairon
{

namespace Core
{

/** \\brief This class is used to disable calling methods by certain type of
 * functors.
 */
class FunctorDisabler
{
	public:
		/** Constructs a FunctorDisabler object. It's refcount is set to zero.
		 */
		FunctorDisabler() : enabled(true), ref(0) {
			mutex = new Mutex();
		};

		/** Destroys the object.
		 */
		~FunctorDisabler() {
			delete mutex;
		};

		/** Decrement number of references to this object.
		 */
		void decRef() {
			mutex->lock();
			if (!--ref) {
				mutex->unlock();
				delete this;
				return;
			}
			mutex->unlock();
		};

		/** Disable functors.
		 */
		void disable() {
			enabled = false;
		};

		/** Increase number of references to this object.
		 */
		void incRef() {
			mutex->lock();
			++ref;
			mutex->unlock();
		};

		/** Returns true if the functors are still enabled.
		 */
		bool isEnabled() {
			return enabled;
		};

	private:
		/** Whether object's using this FunctorDisabler are still enabled.
		 */
		bool enabled;

		/** Mutex for locking this object.
		 */
		Mutex *mutex;

		/** Number of references to this object.
		 */
		unsigned int ref;
};

/** \\brief Base class for executing code in different threads.
 */
class ThreadFunctorCaller
{
	public:
		/** Standard constructor; does nothing.
		 */
		ThreadFunctorCaller() {};

		/** Standard destructor; does nothing.
		 */
		virtual ~ThreadFunctorCaller() {};

		/** This method is called by Tairon::Core::Thread::callFunctors() or
		 * Tairon::Core::Thread::waitAndCallFunctors() to call appropriate
		 * method.
		 */
		virtual void operator()() = 0;
};

/** \\brief Base class for executing code that can be disabled in different
 * threads.
 */
class ThreadDFunctorCaller : public ThreadFunctorCaller
{
	public:
		/** Initializes an object.
		 */
		ThreadDFunctorCaller(FunctorDisabler *d) : ThreadFunctorCaller(), disabler(d) {
			disabler->incRef();
		};

		/** Destroys the object.
		 */
		virtual ~ThreadDFunctorCaller() {
			disabler->decRef();
		};

		/** This method is called by Tairon::Core::Thread::callFunctors() or
		 * Tairon::Core::Thread::waitAndCallFunctors() to call appropriate
		 * method.
		 */
		virtual void operator()() = 0;

	protected:
		/** FunctorDisabler for this object.
		 */
		FunctorDisabler *disabler;
};"""

footer = """
} // namespace Core

} // namespace Tairon

#endif

// vim: ai sw=4 ts=4 noet fdm=marker"""

template = """
/** \\brief Base class for functors.
 *
 * Main usage of this class is with conjunction with signals.
 */
template<class TReturn#tdargs#> class Functor#num#
{
	public:
		/** Standard constructor; does nothing.
		 */
		Functor#num#() {};

		/** Standard destructor; does nothing.
		 */
		virtual ~Functor#num#() {};

		/** This method is used to execute functor's code. It can call other
		 * method or function or whatever else.
		 */
		virtual TReturn operator()(#aargs#) = 0;
};

/** \\brief Functor for calling methods.
 */
template<class TReturn, class TObject#tdargs#> class MethodFunctor#num# : public Functor#num#<TReturn#targs#>
{
	public:
		/** Iinitializes variables holding object and object's method that will
		 * be called. The method shoud be passed as &Class::method.
		 */
		MethodFunctor#num#(TObject *o, TReturn (TObject::*m)(#aargs#)) : Functor#num#<TReturn#targs#>(), object(o), method(m) {};

		/** Standard destructor; does nothing.
		 */
		virtual ~MethodFunctor#num#() {};

		/** Calls method associated with this functor
		 */
		virtual TReturn operator()(#margs#) {
			return (object->*(method))(#args#);
		};

	private:
		/** Object of whose the method should be called.
		 */
		TObject *object;

		/** Method that should be called.
		 */
		TReturn (TObject::*method)(#aargs#);
};

/** Just convenient wrapper for creating method functors.
 */
template<class TReturn, class TObject#tdargs#> inline MethodFunctor#num#<TReturn, TObject#targs#> *methodFunctor(TObject *object, TReturn (TObject::*method)(#aargs#))
{
	return new MethodFunctor#num#<TReturn, TObject#targs#>(object, method);
};

/** \\brief Caller that can be used to call methods in different threads.
 */
template<class TObject#tdargs#> class ThreadMethodFunctorCaller#num# : public ThreadFunctorCaller
{
	public:
		/** Initlaizes variables holding informations about object, its method
		 * and parameters that should be passed to that method.
		 */
		ThreadMethodFunctorCaller#num#(TObject *o, void (TObject::*m)(#aargs#)#cdargs#) : ThreadFunctorCaller(), object(o), method(m)#iargs# {};

		/** Standard destructor; does nothing.
		 */
		virtual ~ThreadMethodFunctorCaller#num#() {};

		/** Calls object's method with parameters previously supplied to the
		 * constructor and deletes itself.
		 */
		virtual void operator()() {
			(object->*(method))(#args#);
			delete this;
		};

	private:
		/** Object of whose the method should be called.
		 */
		TObject *object;

		/** Method that should be called.
		 */
		void (TObject::*method)(#aargs#);#dargs#
};

/** \\brief Functor for calling methods in different threads.
 */
template<class TObject#tdargs#> class ThreadMethodFunctor#num# : public Functor#num#<void#targs#>
{
	public:
		/** Initializes variables holding informations about object, its method
		 * that should be called and the thread in which the method should be
		 * called.
		 */
		ThreadMethodFunctor#num#(Thread *t, TObject *o, void (TObject::*m)(#aargs#)) : Functor#num#<void#targs#>(), thread(t), object(o), method(m) {};

		/** Standard destructor; does nothing.
		 */
		virtual ~ThreadMethodFunctor#num#() {};

		/** Creates ThreadMethodFunctorCaller#num# and adds it to the threads
		 * callers queue.
		 */
		virtual void operator()(#margs#) {
			thread->addFunctorCaller(new ThreadMethodFunctorCaller#num#<TObject#targs#>(object, method#cargs#));
		};

	private:
		/** Thread in which the method should be called.
		 */
		Thread *thread;

		/** Object of whose the method should be called.
		 */
		TObject *object;

		/** Method that should be called.
		 */
		void (TObject::*method)(#aargs#);
};

/** Just convenient wrapper for creating thread method functors.
 */
template<class TObject#tdargs#> inline ThreadMethodFunctor#num#<TObject#targs#> *threadMethodFunctor(Thread *thread, TObject *object, void (TObject::*method)(#aargs#))
{
	return new ThreadMethodFunctor#num#<TObject#targs#>(thread, object, method);
}

/** \\brief Signal is used to call connected functors.
 *
 * It maintains list of connected functors that will be called when emit()
 * method is executed. Note that all connected functors will be deleted when
 * this signal is deleted.
 */
template<class TReturn#tdargs#> class Signal#num# {
	public:
		/** Standard constructor; does nothing.
		 */
		Signal#num#() {};

		/** Deletes all connected functors.
		 */
		~Signal#num#() {
			for (typename std::list<Functor#num#<TReturn#targs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				delete *it;
		};

		/** Disconnects and deletes all connected functors.
		 */
		void clear() {
			for (typename std::list<Functor#num#<TReturn#targs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				delete *it;
			slots.clear();
		};

		/** Connects a functor to this signal.
		 */
		void connect(Functor#num#<TReturn#targs#> *functor) {
			slots.push_back(functor);
		};

		/** Disconnects a functor from this signal.
		 */
		void disconnect(Functor#num#<TReturn#targs#> *functor) {
			for (typename std::list<Functor#num#<TReturn#targs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				if (*it == functor) {
					slots.erase(it);
					return;
				}
		};

		/** Calls all connected functors.
		 */
		void emit(#margs#) {
			typename std::list<Functor#num#<TReturn#targs#> *>::iterator it1, it2;
			// We must create temporary slots list becuase this signal may be
			// deleted before the processing is done. In that case slots
			// wouldn't be valid anymore.
			std::list<Functor#num#<TReturn#targs#> *> temp(slots);
			it1 = temp.begin();
			it2 = ++(temp.begin());
			for (; it1 != temp.end(); ++it2) {
				(**it1)(#args#);
				it1 = it2;
			}
		};

	private:
		/** Functors connected to this signal.
		 */
		std::list<Functor#num#<TReturn#targs#> *> slots;
};

/** \\brief Base class for functors that can be disabled.
 */
template<#tvargs#> class DFunctor#num#
{
	public:
		/** Constructs a functor object.
		 */
		DFunctor#num#() : disabler(0) {};

		/** Destroys the object.
		 */
		virtual ~DFunctor#num#() {
			if (disabler)
				disabler->decRef();
		};

		/** This method is used to execute functor's code. It can call other
		 * method or function or whatever else.
		 */
		virtual void operator()(#aargs#) = 0;

		/** Release disabler used by this functor.
		 */
		void releaseDisabler() {
			disabler->decRef();
			disabler = 0;
		};

		/** Sets disabler used by this functor.
		 */
		void setDisabler(FunctorDisabler *d) {
			disabler = d;
			d->incRef();
		};

	protected:
		/** Disabler for this functor.
		 */
		FunctorDisabler *disabler;
};

/** \\brief Caller that can be used to call methods in different threads.
 */
template<class TObject#tdargs#> class ThreadMethodDFunctorCaller#num# : public ThreadDFunctorCaller
{
	public:
		/** Initlaizes variables holding informations about object, its method
		 * and parameters that should be passed to that method.
		 */
		ThreadMethodDFunctorCaller#num#(TObject *o, void (TObject::*m)(#aargs#), FunctorDisabler *d#cdargs#) : ThreadDFunctorCaller(d), object(o), method(m)#iargs# {};

		/** Standard destructor; does nothing.
		 */
		virtual ~ThreadMethodDFunctorCaller#num#() {};

		/** Calls object's method with parameters previously supplied to the
		 * constructor and deletes itself.
		 */
		virtual void operator()() {
			if (disabler->isEnabled()) {
				(object->*(method))(#args#);
				delete this;
			}
		};

	private:
		/** Object of whose the method should be called.
		 */
		TObject *object;

		/** Method that should be called.
		 */
		void (TObject::*method)(#aargs#);#dargs#
};

/** \\brief DFunctor for calling methods in different threads.
 */
template<class TObject#tdargs#> class ThreadMethodDFunctor#num# : public DFunctor#num#<#aargs#>
{
	public:
		/** Initializes variables holding informations about object, its method
		 * that should be called and the thread in which the method should be
		 * called.
		 */
		ThreadMethodDFunctor#num#(Thread *t, TObject *o, void (TObject::*m)(#aargs#)) : DFunctor#num#<#aargs#>(), thread(t), object(o), method(m) {};

		/** Standard destructor; does nothing.
		 */
		virtual ~ThreadMethodDFunctor#num#() {};

		/** Creates ThreadMethodFunctorCaller#num# and adds it to the threads
		 * callers queue.
		 */
		virtual void operator()(#margs#) {
			// why the hell there is a need to add DFunctor#num#<#aargs#>:: before disabler?
			thread->addFunctorCaller(new ThreadMethodDFunctorCaller#num#<TObject#targs#>(object, method, DFunctor#num#<#aargs#>::disabler#cargs#));
		};

	private:
		/** Thread in which the method should be called.
		 */
		Thread *thread;

		/** Object of whose the method should be called.
		 */
		TObject *object;

		/** Method that should be called.
		 */
		void (TObject::*method)(#aargs#);
};

/** Just convenient wrapper for creating thread method functors that can be
 * disabled.
 */
template<class TObject#tdargs#> inline ThreadMethodDFunctor#num#<TObject#targs#> *threadMethodDFunctor(Thread *thread, TObject *object, void (TObject::*method)(#aargs#))
{
	return new ThreadMethodDFunctor#num#<TObject#targs#>(thread, object, method);
}

/** \\brief DSignal is used to call connected functors, but allows disabling them.
 *
 * It maintains list of connected functors that will be called when emit()
 * method is executed. Note that all connected functors will be deleted when
 * this signal is deleted.
 */
template<#tvargs#> class DSignal#num# {
	public:
		/** Initializes functor disabler.
		 */
		DSignal#num#() {
			disabler = new FunctorDisabler();
			disabler->incRef();
		};

		/** Deletes all connected functors and frees all other allocated
		 * resources.
		 */
		~DSignal#num#() {
			for (typename std::list<DFunctor#num#<#aargs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				delete *it;
			disabler->decRef();
		};

		/** Disconnects and deletes all connected functors.
		 */
		void clear() {
			for (typename std::list<DFunctor#num#<#aargs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				delete *it;
			slots.clear();
		};

		/** Connects a functor to this signal.
		 */
		void connect(DFunctor#num#<#aargs#> *functor) {
			functor->setDisabler(disabler);
			slots.push_back(functor);
		};

		/** Disables connected functors.
		 */
		void disable() {
			disabler->disable();
		};

		/** Disconnects a functor from this signal.
		 */
		void disconnect(DFunctor#num#<#aargs#> *functor) {
			for (typename std::list<DFunctor#num#<#aargs#> *>::iterator it = slots.begin(); it != slots.end(); ++it)
				if (*it == functor) {
					functor->releaseDisabler();
					slots.erase(it);
					return;
				}
		};

		/** Calls all connected functors.
		 */
		void emit(#margs#) {
			typename std::list<DFunctor#num#<#aargs#> *>::iterator it1, it2;
			it1 = slots.begin();
			it2 = ++(slots.begin());
			for (; it1 != slots.end(); ++it2) {
				(**it1)(#args#);
				it1 = it2;
			}
		};

		/** Enables connected functors. This applies only for new emission.
		 */
		void enable() {
			if (disabler->isEnabled())
				return;
			disabler->decRef();
			disabler = new FunctorDisabler();
			disabler->incRef();
		}

	private:
		/** Disabler used to disable called functors.
		 */
		FunctorDisabler *disabler;

		/** Functors connected to this signal.
		 */
		std::list<DFunctor#num#<#aargs#> *> slots;
};"""

def printTemplate(i):
	num = str(i)
	tdargs = "".join([", class TArg" + str(j) for j in xrange(1, i + 1)])
	tvargs = tdargs[2:]
	targs = "".join([", TArg" + str(j) for j in xrange(1, i + 1)])
	aargs = targs[2:]
	margs = "".join([", TArg" + str(j) + " arg" + str(j) for j in xrange(1, i + 1)])[2:]
	cargs = "".join([", arg" + str(j) for j in xrange(1, i + 1)])
	dargs = "".join(["\n		TArg" + str(j) + " arg" + str(j) + ";" for j in xrange(1, i + 1)])
	args = cargs[2:]
	cdargs = "".join([", TArg" + str(j) + " a" + str(j) for j in xrange(1, i + 1)])
	iargs = "".join([", arg" + str(j) + "(a" + str(j) + ")" for j in xrange(1, i + 1)])

	lines = template.replace("#num#", num).replace("#tdargs#", tdargs).replace("#tvargs#", tvargs).replace("#targs#", targs).replace("#aargs#", aargs).replace("#margs#", margs).replace("#dargs#", dargs).replace("#cargs#", cargs).replace("#args#", args).replace("#iargs#", iargs).replace("#cdargs#", cdargs).replace("template<> ", "").replace("<>", "").splitlines()

	# remove typenames...
	i = 0
	while i < len(lines):
		if lines[i].find("DFunctor0") != -1:
			lines[i] = lines[i].replace("typename ", "")
		i += 1
	return "\n".join(lines)

if __name__ == "__main__":
	if len(sys.argv) == 2:
		sys.stdout = file(sys.argv[1], "w")

	print header

	for i in xrange(signalCount):
		print printTemplate(i)

	print footer
